# $Id: xchain-binutils.make,v 0.3.2.1 2002/09/11 22:00:00 robert Exp $
#
# (c) 2002 by Pengutronix e.K., Hildesheim, Germany
# See CREDITS for details about who has contributed to this project. 
#
# For further information about the PTXDIST project and license conditions
# see the README file.
#

#
# We provide this package
#
ifeq (y,$(PTXCONF_BUILD_CROSSCHAIN))
PACKAGES += xchain-binutils
endif

#
# Paths and names 
#
BINUTILS		= binutils-2.11.2
BINUTILS_URL		= ftp://ftp.gnu.org/pub/gnu/binutils/$(BINUTILS).tar.gz
BINUTILS_SOURCE		= $(SRCDIR)/$(BINUTILS).tar.gz
BINUTILS_DIR		= $(BUILDDIR)/$(BINUTILS)
BINUTILS_EXTRACT 	= gzip -dc

# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

xchain-binutils_get: $(STATEDIR)/xchain-binutils.get

$(STATEDIR)/xchain-binutils.get: $(BINUTILS_SOURCE)
	touch $@

$(BINUTILS_SOURCE):
	@echo
	@echo ------------------- 
	@echo xchain-binutils.get
	@echo -------------------
	@echo
	wget -P $(SRCDIR) $(PASSIVEFTP) $(BINUTILS_URL)

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

xchain-binutils_extract: $(STATEDIR)/xchain-binutils.extract

$(STATEDIR)/xchain-binutils.extract: $(STATEDIR)/xchain-binutils.get
	@echo
	@echo ----------------------- 
	@echo xchain-binutils.extract
	@echo -----------------------
	@echo
	$(BINUTILS_EXTRACT) $(BINUTILS_SOURCE) | $(TAR) -C $(BUILDDIR) -xf -
	touch $@

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

xchain-binutils_prepare: $(STATEDIR)/xchain-binutils.prepare

$(STATEDIR)/xchain-binutils.prepare: $(STATEDIR)/xchain-binutils.extract
	@echo
	@echo ----------------------- 
	@echo xchain-binutils.prepare
	@echo -----------------------
	@echo
	cd $(BINUTILS_DIR) && 						\
	./configure 							\
		--disable-shared					\
		--target=arm-linux					\
		--prefix=$(PTXCONF_CROSSCHAIN_PREFIX) 		\
		--enable-targets=arm-linux	
	touch $@

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

xchain-binutils_compile: $(STATEDIR)/xchain-binutils.compile

$(STATEDIR)/xchain-binutils.compile: $(STATEDIR)/xchain-binutils.prepare 
	@echo
	@echo ----------------------- 
	@echo xchain-binutils.compile
	@echo -----------------------
	@echo
	make -C $(BINUTILS_DIR)
	touch $@

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

xchain-binutils_install: $(STATEDIR)/xchain-binutils.install

$(STATEDIR)/xchain-binutils.install: $(STATEDIR)/xchain-binutils.compile
	@echo
	@echo ----------------------- 
	@echo xchain-binutils.install
	@echo -----------------------
	@echo
	[ -d $(PTXCONF_CROSSCHAIN_PREFIX) ] || 			\
		$(SUDO) install -g wheel -m 0755 			\
				-o $(PTXUSER) 				\
				-d $(PTXCONF_CROSSCHAIN_PREFIX)
	make -C $(BINUTILS_DIR) install
	touch $@

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

xchain-binutils_clean: 
	rm -rf $(STATEDIR)/xchain-binutils.* $(BINUTILS_DIR)

# vim: syntax=make
